<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
 xmlns:regexp="xalan://fr.fluxmedia.transmorpher.regexp.RegularExpression">

<!-- ************************************************************ -->
<!--        This style sheet was generated by Transmorpher        -->
<!-- ************************************************************ -->


  <!-- Copying the root and its attributes -->
  <xsl:template match="/">
    <xsl:apply-templates/>
  </xsl:template>
  <xsl:template match="@*">
    <xsl:attribute name="{name()}"><xsl:value-of select="."/>
    </xsl:attribute>
  </xsl:template>

  <!-- Copying all elements and attributes -->
  <xsl:template match="*">
    <xsl:copy>
      <xsl:apply-templates select="*|@*|text()"/>
    </xsl:copy>
  </xsl:template>

<!-- ************************************************************ -->
<!--     End of the general section, here begins the stylesheet   -->
<!-- ************************************************************ -->

  <!-- Removing elements abstract -->
  <xsl:template match="reference/abstract"/>

  <!-- Removing elements keywords -->
  <xsl:template match="reference/keywords"/>

  <!-- Removing elements areas -->
  <xsl:template match="reference/areas"/>

  <!-- Removing elements softwares -->
  <xsl:template match="reference/softwares"/>

  <!-- Removing elements contracts -->
  <xsl:template match="reference/contracts"/>

  <!-- Removing elements *[@status='hidden'] -->
  <xsl:template match="*[@status='hidden']"/>

  <!-- Substituting all ([0-9]+) by $1e in conference/@issue -->
  <xsl:template match ="conference/@issue">
    <xsl:if test="function-available('regexp:substitute') and function-available('regexp:substituteAll') ">
      <xsl:attribute name="issue">
        <xsl:value-of select="regexp:substituteAll(.,'([0-9]+)','$1e')"/>
      </xsl:attribute>
    </xsl:if>
  </xsl:template>

  <!-- Removing attributes status -->
  <xsl:template match="@status"/>

</xsl:stylesheet>
