/**
 * $Id: ApplyProcess.java,v 1.9 2001/10/07 03:49:00 laurent Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/**
  * Transmorpher graph call node interface
  *
  * @author Jerome.Euzenat@inrialpes.fr
  * @since jdk 1.3 / SAX 2.0
  */

package fr.fluxmedia.transmorpher.Graph ;


import fr.fluxmedia.transmorpher.Files.ReadWrite;
import fr.fluxmedia.transmorpher.Utils.LinearIndexedStruct ;
import java.util.ListIterator;

public class ApplyProcess
  extends ApplyImpl {

  public ApplyProcess (String n, String t, Process p, String pr, int in, int out){
    super(n, t, p, pr, in, out);
  }

  /** ask a nullify call to the called process */
  public void retroNull( PortList out, PortList in) {
      // JE: check is it is a Process
      Process called = (Process)(getProcess().getTransmorpher().getTransformation(getRef()));
      nullified = called.retroNull(out, in, true);
      visited = true;
  }
  
  public void generateXML (){
    System.out.print("      <apply-process id=\""+id+"\" ref=\""+getRef()+"\" ");
    System.out.print("in=\"");
    inPorts.generateXML();
    System.out.print("\" out=\"");
    outPorts.generateXML();
    if ( parameters.isEmpty() ){
      System.out.println("\"/>");
    } else {
      System.out.println("\">");
      parameters.generateXMLCalls();
      System.out.println("      </apply-process>");
    }
  } //end generate XML

  public void setUp(){
    if( getProcess().getTransmorpher().getTransformation(getRef()) == null ){
      System.err.println("warning : unknown process : "+getRef());
    }
  } //end setUp
   
   
//     public void generateJavaCode(ReadWrite file){
//    if(file == null) {
//      System.out.println(getId()+" [generateCode]: erreur the file is null!!");
//    } else {
//      file.Writeln("");
//      file.Writeln(4,"//------------------Generation of a Dispatcher -------------------");
//      generatePorts(file);
//      generateParameters(file);
//      file.Writeln(4,"TProcess "+getId()
//                      +" = myProcessFactory.newDispatcher(portIn,portOut,"
//                      +"myParameters,"
//                      +"myAttributes);");
//      file.Writeln(4,getId()+".setName(\""+getId()+"\");");
//      file.Writeln("");
//      //TODO
//      file.Writeln("myMain.addProcess(" + getId()+");");
//
//    } //end if
//  } //end proc
   
//  protected final String[] convertPortList(PortList p) {
//    int size =p.length() ;
//    String[] vPort = new String[size] ;
//    for (int i=0; i<size; i++) { vPort[i]= p.getPort(i).getName(); } //end for
//    return vPort ;
//  } //end proc
   
 public void generateJavaCode(ReadWrite iFile){
          
    if(iFile == null) {
      System.out.println(getId()+" [generateCode]: erreur the file is null!!");
    } else {
      iFile.Writeln("");
      iFile.Writeln(4,"//------------------Generation of a ApplyProcess -------------------");
      generatePorts(iFile);
      generateParameters(iFile);
      iFile.Writeln("");
      iFile.Writeln(4,"TApplyProcess "+getId()
                      +" = (TApplyProcess)myProcessFactory.newApplyProcess(portIn,portOut,"
                      +"myParameters"
                      +",myAttributes);");
      iFile.Writeln(4,getId()+".setName(\""+getId()+"\");");
      iFile.Writeln("");
      generateLocalName(iFile);
      iFile.Writeln("");
    } //end if
  } //emd proc
   /*
    String[] vPortIn = convertPortList(currentGraphElement.inPorts());
    String[] vPortOut = convertPortList(currentGraphElement.outPorts());
    String r = currentGraphElement.getAttributes().getStringParameter("ref") ;
    LinearIndexedStruct vCalls = ((fr.fluxmedia.transmorpher.Graph.Process)iTransmorpher.getTransformation(r)).getCalls();
            
    //System.out.println("[ExecutionStructure]ApplyProcess : getTransformation"
    //                    +((fr.fluxmedia.transmorpher.Graph.Process)iTransmorpher.getTransformation(r)));
            
    TProcess vCurrent = TProcessFactory.newApplyProcess(vPortIn,vPortOut,
                                                        currentGraphElement.getParameters(),
                                                        currentGraphElement.getAttributes());
    PortList LocIn = ((fr.fluxmedia.transmorpher.Graph.Process)iTransmorpher.getTransformation(r)).inPorts();
    PortList LocOut= ((fr.fluxmedia.transmorpher.Graph.Process)iTransmorpher.getTransformation(r)).outPorts();
            
    ((TApplyProcess)vCurrent).setLocalName(LocIn.getNames(),LocOut.getNames());
*/
  public void generateLocalName(ReadWrite file) {
    String r = getAttributes().getStringParameter("ref") ;
    Transmorpher tr = getProcess().getTransmorpher();
    file.Writeln(4,"LocIn = new String["+ ((fr.fluxmedia.transmorpher.Graph.Process)tr.getTransformation(r)).inPorts().getNames().length+"];");
    for(int i=0;i<((fr.fluxmedia.transmorpher.Graph.Process)tr.getTransformation(r)).inPorts().length();i++){
      file.Writeln(4,"LocIn["+i+"]=\""+((fr.fluxmedia.transmorpher.Graph.Process)tr.getTransformation(r)).inPorts().getNames()[i]+"\";");
    } //end for
    file.Writeln(4,"LocOut = new String["+((fr.fluxmedia.transmorpher.Graph.Process)tr.getTransformation(r)).outPorts().getNames().length+"];");
    for(int i=0;i<((fr.fluxmedia.transmorpher.Graph.Process)tr.getTransformation(r)).outPorts().length();i++){
      file.Writeln(4,"LocOut["+i+"]=\""+((fr.fluxmedia.transmorpher.Graph.Process)tr.getTransformation(r)).outPorts().getNames()[i]+"\";");
    } //end for
    file.Writeln(4,getId()+".setLocalName(LocIn,LocOut);");
  } //end proc

   
} //end class
