/**
 * $Id: ApplyRuleset.java,v 1.9 2001/10/07 03:49:00 laurent Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/**
  * Transmorpher graph call node interface
  *
  * @author Jerome.Euzenat@inrialpes.fr
  * @since jdk 1.3 / SAX 2.0
  */

package fr.fluxmedia.transmorpher.Graph ;


import fr.fluxmedia.transmorpher.Files.ReadWrite;


public class ApplyRuleset
 extends ApplyImpl {

 public ApplyRuleset (String n, String t, Process p, String r, String s){
   super(n, t, p, r, 1, 1);
   // JE I still do not like to have these attributes in parameters
   iAttributes.setParameter("strategy",s);
 }

  public ApplyRuleset (String n, String t, Process p, String r){
   this(n, t, p, r, "one-pass/top-down/apply-once");
  }

  /** Propagate the nullify of its sole output to all the input. */
  public void retroNull( PortList out, PortList in) {
      nullified = out.getPort(0).getChannel().nullifiedP();
      in.getPort(0).getChannel().setVisited();
      if ( nullified ) in.getPort(0).getChannel().nullify();
      visited = true;
  }
  
  public final void setStrategy( String s ){
    iAttributes.setParameter("strategy",s);
  }
 
  public final String getStrategy(){
    return iAttributes.getStringParameter("strategy");
  }

  public final void generateXML (){
    System.out.print("      <apply-ruleset id=\""+id+"\" ref=\""+getRef()+"\" strategy=\""+getStrategy()+"\" ");
    System.out.print("in=\"");
    inPorts.generateXML();
    System.out.print("\" out=\"");
    outPorts.generateXML();
    if ( parameters.isEmpty() ){
      System.out.println("\"/>");
    } else {
      System.out.println("\">");
      parameters.generateXMLCalls();
      System.out.println("      </apply-ruleset>");
    }
  }

  public final void setUp(){
    if( getProcess().getTransmorpher().getTransformation(getRef()) == null ){
      System.err.println("warning : unknown ruleset : "+getRef());
    } //end if
  } //end proc
    
  
     public void generateJavaCode(ReadWrite file){
    if(file == null) {
      System.out.println(getId()+" [generateCode]: erreur the file is null!!");
    } else {
      file.Writeln("");
      file.Writeln(4,"//------------------Generation of an applyRuleSet -------------------");
      generatePorts(file);
      generateParameters(file);
      file.Writeln(4,"TProcess "+getId()
                      +" = myProcessFactory.newRuleSet(portIn,portOut,"
                      +"myParameters"
                      +",myAttributes);");
      file.Writeln(4,getId()+".setName(\""+getId()+"\");");
      file.Writeln("");
      //TODO
      file.Writeln(4,"myCurrentCompositeProcess.addProcess(" + getId()+");");
     
    } //end if
  } //end proc
  
} //end class
