/**
 * $Id: Channel.java,v 1.6 2001/10/01 13:22:09 jerome Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/**
  * Transmorpher graph channel representation
  *
  * @author Jerome.Euzenat@inrialpes.fr
  * @since jdk 1.3 / SAX 2.0
  */

package fr.fluxmedia.transmorpher.Graph ;

import fr.fluxmedia.transmorpher.Files.ReadWrite;

public class Channel {

  Port in = null;
  Port out = null;
  String name = null;
  boolean visited = false;
  boolean nullified = false;
  Process process = null;

  public Channel(String n, Process p){
    name = n;
  }

  public Channel(String n, Process p, Port i, Port o){
    this(n,p);
    in = i;
    out = o;
  }

  public Port in() { return in;}
  public Port out() {return out;}
  public void setIn(Port p) { in = p;}
  public void setOut(Port p) {out = p;}
  public String getName(){return name;}
  public Process getProcess(){ return process;}
  public void clearNull() { nullified = false;}
  public void nullify() { nullified = true;}
  public void clearVisited() { visited = false;}
  public void setVisited() { visited = true;}
  public boolean visitedP() { return visited;}
  public boolean nullifiedP() { return nullified;}
     
  /** Prints the Java code for the execution of the call */
    void generateJavaCode(ReadWrite file){
	System.err.println("Channel .generateJavaCode() : not implemented yet");
    }

} //end class
