/**
 * $Id: Generate.java,v 1.12 2001/10/19 09:00:27 jerome Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/**
  * Transmorpher graph generator node interface
  *
  * @author Jerome.Euzenat@inrialpes.fr
  * @since jdk 1.3 / SAX 2.0
  */

/** CAUTION, This will have to change the parameter cannot always be a file */

package fr.fluxmedia.transmorpher.Graph ;

import fr.fluxmedia.transmorpher.Files.ReadWrite;

public class Generate
  extends CallImpl {
   
  public Generate (String n, String t, Process p, int out){
    super(n, t, p, 0, out);
  }

   
  /** For compatibility with pre-1.0 Transmorpher */
  public Generate (String n, String t, Process p, int out, String file){
    this(n, t, p, out);
    /** This is for legacy code */
    if (file != null ) parameters.setParameter("file",file);
  }

      /** A generate can be nullified but it will propagate to nothing */
  public void retroNull( PortList out, PortList in) {
      nullified = out.getPort(0).getChannel().nullifiedP();
      visited = true;
  }
  
  public void generateXML (){
    System.out.print("      <generate id=\""+id+"\" type=\""+getType()+"\"");
    System.out.print(" out=\"");
    outPorts.generateXML();
    if ( parameters.isEmpty() ){
      System.out.println("\"/>");
    } else {
      System.out.println("\">");
      parameters.generateXMLCalls();
      System.out.println("      </generate>");
    }
  }//end generate xml
 
  public void generateJavaCode(ReadWrite file){
    if(file == null) {
      System.out.println(getId()+" [generateCode]: erreur the file is null!!");
    } else {
      file.Writeln("");
      file.Writeln(4,"//------------------Generation of a generator-------------------");
      generatePorts(file);
      generateParameters(file);
      file.Writeln("");
      file.Writeln(4,"TProcess "+getId()
                      +" = myProcessFactory.newGenerator(portOut,"
                      +"myParameters,"
                      +"myAttributes);");
      file.Writeln(4,getId()+".setName(\""+getId()+"\");");
      file.Writeln("");
      //TODO
      file.Writeln(4,"myCurrentCompositeProcess.addProcess(" + getId()+");");
     
    } //end if
  } //end proc
   
  
} //end class
