/**
 * $Id: RepeatProcess.java,v 1.2 2001/10/19 15:33:08 jerome Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/**
  * Transmorpher graph processes definitions
  *
  * @author Jerome.Euzenat@inrialpes.fr
  * @since jdk 1.3 / SAX 2.0
  */

package fr.fluxmedia.transmorpher.Graph ;

import java.util.Hashtable;
import java.util.Enumeration;
import java.util.ListIterator;
import java.util.Stack;

import fr.fluxmedia.transmorpher.Utils.LinearIndexedStruct;
import fr.fluxmedia.transmorpher.Files.ReadWrite;

public class RepeatProcess
  extends Process {

    private Repeat caller = null;

  public RepeatProcess(String n, Repeat r, int nin, int nout){
    super(n,(Transmorpher)null,nin,nout);
    caller = r;
  }

  /** Prints the XML expression of the process */
  public void generateXML(){
    for( ListIterator l = calls.listIterator(); l.hasNext() ; ){
      ((Call)l.next()).generateXML();
    }
  }

    /** Prints the Java code for the execution of the call */
    public void generateJavaCode(ReadWrite file){
	System.out.println("[RepeatProcess]generateJavaCode : not yet implemented");
    }

    public void setUp(){
	for( ListIterator l = calls.listIterator(); l.hasNext() ; ){
	    ((Call)l.next()).setUp();
	}
    }

    public Repeat getCaller(){
	return caller;
    }

    /** This implementation takes into account the fact that
        this particular process body is imbedded into a Call.
	This works recursively since that call can be embedded
        in the same way and then will use the same kind of getTransmorpher. */
    public Transmorpher getTransmorpher(){
        return caller.getProcess().getTransmorpher();
    }

    public void exec(){
	System.err.println("RepeatProcess.exec() : not implemented yet");
    }
 
} //end class
