/**
 * $Id: Serialize.java,v 1.11 2001/10/19 09:00:27 jerome Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/**
  * Transmorpher graph serializer node interface
  *
  * @author Jerome.Euzenat@inrialpes.fr
  * @since jdk 1.3 / SAX 2.0
  */

/** CAUTION, This will have to change the parameter cannot always be a file */

package fr.fluxmedia.transmorpher.Graph ;

import fr.fluxmedia.transmorpher.Files.ReadWrite;

public class Serialize extends CallImpl {

  public Serialize (String n, String t, Process p, int in){
    super(n, t, p, in, 0);
  }

  /** For compatibility with pre-1.0 Transmorpher */
  public Serialize (String n, String t, Process p, int in, String file){
    this(n, t, p, in);
    /** This is for legacy code */
    if (file != null ) parameters.setParameter("file",file);
  }

      /** A serialize cannot be nullified */
  public void retroNull( PortList out, PortList in) {
      visited = true;
      in.getPort(0).getChannel().setVisited();
  }
  
  public void generateXML (){
    System.out.print("      <serialize id=\""+id+"\" type=\""+getType()+"\"");
    System.out.print(" in=\"");
    inPorts.generateXML();
    if ( parameters.isEmpty() ){
      System.out.println("\"/>");
    } else {
      System.out.println("\">");
      parameters.generateXMLCalls();
      System.out.println("      </serialize>");
    }
  }

  public void generateJavaCode(ReadWrite file){
    if(file == null) {
      System.out.println(getId()+" [generateCode]: erreur the file is null!!");
    } else {
      file.Writeln("");
      file.Writeln(4,"//------------------Generation of a serializer-------------------");
      generatePorts(file);
      generateParameters(file);
      file.Writeln(4,"TProcess "+getId()
                      +" = myProcessFactory.newSerializer(portIn,"
                      +"myParameters,"
                      +"myAttributes);");
      file.Writeln(4,getId()+".setName(\""+getId()+"\");");
      file.Writeln("");
      //TODO
      file.Writeln(4,"myCurrentCompositeProcess.addProcess(" + getId()+");");
     
    } //end if
  } //end proc

}
