/**
 * $Id: CompilationFactory.java,v 1.5 2001/11/12 12:57:34 jerome Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/**
 * CompilationFactory.java : define the structure for a transmorpher execution
 *
 * @author Laurent Tardif
 */

package fr.fluxmedia.transmorpher.Parser;

//import XML CLasses

import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerConfigurationException;

// import SAX classes
import org.xml.sax.SAXException;


// import java classes
import java.util.Hashtable;
import java.util.Vector;
import java.util.Enumeration;
import java.util.ListIterator;
import java.io.IOException;
import java.io.File;

//import transmorpher classes

import fr.fluxmedia.transmorpher.TProcessFactory.TProcess;
import fr.fluxmedia.transmorpher.TProcessFactory.TApplyProcess;
import fr.fluxmedia.transmorpher.TProcessFactory.TProcessComposite;
import fr.fluxmedia.transmorpher.TProcessFactory.TMain;
import fr.fluxmedia.transmorpher.TProcessFactory.TProcessFactory;

import fr.fluxmedia.transmorpher.Graph.Main;
import fr.fluxmedia.transmorpher.Graph.*;

import fr.fluxmedia.transmorpher.Utils.LinearIndexedStruct ;
import fr.fluxmedia.transmorpher.Files.ReadWrite ;
import fr.fluxmedia.transmorpher.Files.Constants ;

public class CompilationFactory {
  
 String iCompilDirectory = null;
 ReadWrite iFile = null;
 
  public CompilationFactory(fr.fluxmedia.transmorpher.Graph.Transmorpher pTransmorpher, String reloc) {
    try {
  	  //iCompilDirectory = pTransmorpher.getFile().getAbsoluteFile().getParent() + File.separator +"Compil";
	    iCompilDirectory = pTransmorpher.getFile().getAbsoluteFile().getParent();
	    if( reloc != null) {
	      iCompilDirectory = reloc;
	    } else {
	     iCompilDirectory = pTransmorpher.getFile().getAbsoluteFile().getParent();
	    }
      File dir = new File(iCompilDirectory);
      dir.mkdir(); // directly tries to create the directory that might exist
      iCompilDirectory+=File.separator;
      iFile = new ReadWrite(iCompilDirectory+pTransmorpher.getMain().getName()+".java", Constants.WRITE);
      // JE: I would have prefered to see some generic code here
      // after all, this should really be in the graph objects.
      if (pTransmorpher.getMain() instanceof Main) {
        generateHeader((Main)pTransmorpher.getMain());
      } else if (pTransmorpher.getMain() instanceof Servlet) {
        generateHeader((fr.fluxmedia.transmorpher.Graph.Servlet)pTransmorpher.getMain());
      } else {
        generateHeader((fr.fluxmedia.transmorpher.Graph.Transformer)pTransmorpher.getMain());
      }
      generateJavaCode((Main)(pTransmorpher.getMain()));
      generateEnd();
    } catch (Exception e) {
      System.out.println("Error:" + e );
    } //end try
  } //end
 
  public void compil() throws Exception {
   
  }
 
    // JE: why not pMain directly to the third line?
  private void generateJavaCode(Main pMain) throws Exception {
    Transformation currentGraphElement = null ;
    currentGraphElement = pMain ;
    startMain(currentGraphElement);
  }
  
  public final void startProcess(Transformation currentGraphElement,TProcess currentProcess ) {
    String localName = currentGraphElement.getType();
    try {
      
      if (currentGraphElement  instanceof fr.fluxmedia.transmorpher.Graph.Process) {
          //System.out.println("startElement(Transformation): " + localName);
          //startProcess();
	  // JE: et on fait quoi si on est une servlet ou un transformer?
	  // Et si je disais que Main est une sous-classe de Process?...
      } else if (currentGraphElement  instanceof Main) {
          //On appel le run a la fin du main
          //System.out.println("startElement (Transformation) : " + localName);
          startMain(currentGraphElement);
      } else {
          System.out.println("startElement (Transformation) : ELEMENT INCONU" + localName);
      } //end if
      
    } catch (Exception e) {
      System.out.println("Erreur"+e);
    }//end try
  } // startElement(String namespaceURI, String localName, String qname, Attributes atts)
 
 public final TProcess startProcess(Call currentGraphElement) {
    String localName = currentGraphElement.getId();
    try {
      
       if (currentGraphElement  instanceof ApplyExternal) {
          //System.out.println("startElement (Call)(Xslt_) : " + localName);
          startProcessXslt(currentGraphElement);
      } else if (currentGraphElement  instanceof ApplyProcess) {
          //System.out.println("startElement (Call)(ApplyProcess) : " + localName);
          startProcessApplyProcess(currentGraphElement);
      } else if (currentGraphElement  instanceof ApplyQuery) {
          //System.out.println("startElement (Call)(query) : " + localName);
          startProcessQuery(currentGraphElement);
      } else if (currentGraphElement  instanceof ApplyRuleset) {
          //System.out.println("startElement (Call) (ApplyRuleset):  " + localName);
          startRuleSet(currentGraphElement);
      } else if (currentGraphElement  instanceof Generate) {
          //System.out.println("startElement (Call)(Generate) : " + localName);
          startProcessReader(currentGraphElement);
      } else if (currentGraphElement  instanceof Serialize) {
          //System.out.println("startElement (Call) (Serialize): " + localName);
          startProcessSerializer(currentGraphElement);
      } else if (currentGraphElement  instanceof Dispatch ) {
          //System.out.println("startElement (Call) (Dispatch): " + localName);
          startProcessDispatcher(currentGraphElement);
      } else if (currentGraphElement  instanceof Merge) {
          //System.out.println("startElement (Call) (Merge): " + localName);
          startProcessConnector(currentGraphElement);
      } else {
          System.out.println("[ExecutionStructure]startElement (Call) : ELEMENT INCONU" + localName);
      } //end if
      
    } catch (Exception e) {
      System.out.println("[ExecutionStructure]startElement : Erreur"+e);
      e.printStackTrace();
    }//end try
   return null;
  } // startElement(String namespaceURI, String localName, String qname, Attributes atts)
  
 
 
  protected final String[] convertPortList(PortList p) {
    int size =p.length() ;
    String[] vPort = new String[size] ;
    for (int i=0; i<size; i++) { vPort[i]= p.getPort(i).getName(); } //end for
   return vPort ;
  } //end proc
 
  protected final void startMain(Transformation pMain){
   iFile.Writeln(4,"TMain "+ pMain.getName() +"= (TMain) myProcessFactory.newMain(new String[0], new String[0]);");
   iFile.Writeln(4,"myCurrentCompositeProcess ="+ pMain.getName()+" ;");
   for( ListIterator l = ((fr.fluxmedia.transmorpher.Graph.Process)pMain).getCalls().listIterator(); l.hasNext() ; ){
      startProcess(((Call)l.next()));
    }
   // JE: here the parameters variable should be passed in argument to execProcess()
   iFile.Writeln(4,pMain.getName()+".execProcess();");
  } //end proc

    // JE: this is bad software engineering: so much cut and paste
    // and moreover, this is never called, startMain should be called for servlet...
    // THE SERIOUS QUESTION: is there any need for a TServlet ?? since we are deep in the
    // inside of the process and that everything has been set into the headers, I suspect
    // that ideal TMain and TServlet must do exactly the same...

  protected final void startServlet(Transformation pMain){
   iFile.Writeln(4,"TServlet "+ pMain.getName() +"= (TServlet) myProcessFactory.newMain(new String[0], new String[0]);");
   iFile.Writeln(4,"myCurrentCompositeProcess ="+ pMain.getName()+" ;");
   for( ListIterator l = ((fr.fluxmedia.transmorpher.Graph.Process)pMain).getCalls().listIterator(); l.hasNext() ; ){
      startProcess(((Call)l.next()));
    }
   // JE: here the parameters variable should be passed in argument to execProcess()
   iFile.Writeln(4,pMain.getName()+".execProcess();");
  } //end proc
 
  protected  final void startProcessReader(Call currentGraphElement){
    currentGraphElement.generateJavaCode(iFile);
  } //end proc

  protected  final void startProcessSerializer(Call currentGraphElement) {
    currentGraphElement.generateJavaCode(iFile);
  } //end proc

 
 protected  final void startProcessDispatcher(Call currentGraphElement) {
    currentGraphElement.generateJavaCode(iFile);
  } //end proc

 

  protected  final void startProcessConnector(Call currentGraphElement) {
    currentGraphElement.generateJavaCode(iFile);
  } //end proc



  protected  final void startProcessXslt(Call currentGraphElement){
    currentGraphElement.generateJavaCode(iFile);
  } //end proc
     
  protected  final void startRuleSet(Call currentGraphElement) {
    String ref = currentGraphElement.getAttributes().getStringParameter("ref");
    Transmorpher tr = currentGraphElement.getProcess().getTransmorpher() ;
    String f = tr.getTransformation(ref).getAttributes().getStringParameter("file");
    //static car construit a partir du nom de l'elelent
    currentGraphElement.getAttributes().setParameter("file",f);

    currentGraphElement.generateJavaCode(iFile);
  } //end proc

  protected  final void startProcessQuery(Call currentGraphElement) {
    String ref = currentGraphElement.getAttributes().getStringParameter("ref");
    Transmorpher tr = currentGraphElement.getProcess().getTransmorpher() ;
    String f = tr.getTransformation(ref).getAttributes().getStringParameter("file");
    //static car construit a partir du nom de l'elelent
    currentGraphElement.getAttributes().setParameter("file",f);
    currentGraphElement.generateJavaCode(iFile);
    
  } //end proc

  protected  final void startProcessApplyProcess(Call currentGraphElement) {

    String r = currentGraphElement.getAttributes().getStringParameter("ref") ;
    Transmorpher tr = currentGraphElement.getProcess().getTransmorpher() ;
    LinearIndexedStruct vCalls = ((fr.fluxmedia.transmorpher.Graph.Process)tr.getTransformation(r)).getCalls();
            
    currentGraphElement.generateJavaCode(iFile);
   
    iFile.Writeln(4,"myCurrentCompositeProcess = " + currentGraphElement.getId() +";");
    for( ListIterator l = vCalls.listIterator(); l.hasNext() ; ){
      startProcess(((Call)l.next())); //change current
    }
    //changement de nom des ports
   
    //TODO
    iFile.Writeln(4,"myCurrentCompositeProcess = " + currentGraphElement.getProcess().getName() +";");
    iFile.Writeln(4,"myCurrentCompositeProcess.addProcess(" + currentGraphElement.getId()+");");
    iFile.Writeln(4,"//---------------------------------- End of compotire -----------------");
    iFile.Writeln("");
    iFile.Writeln("");
    //currentProcess.addProcess(vCurrent);
  } //end proc

  public void generateHeader(Main main) {
    iFile.Writeln("/** Generated by Transmorpher */");
    iFile.Writeln("");
    iFile.Writeln("// import transmorpher classes");
    iFile.Writeln("import fr.fluxmedia.transmorpher.TProcessFactory.*;");
    iFile.Writeln("import fr.fluxmedia.transmorpher.Utils.*;");
    iFile.Writeln("import fr.fluxmedia.transmorpher.Utils.SystemResources ;");
    iFile.Writeln();
    iFile.Writeln("public class "+main.getName()+" {");
    iFile.Writeln();
    // La valeur par defaut devrait etre celle de ce Transmorpher.
    iFile.Writeln(2,"boolean debug_mode = false;");
    iFile.Writeln(4,"Parameters parameters = null ;");
    iFile.Writeln();
    iFile.Writeln(2,"public static void main(String[] argc) throws Exception {");
    iFile.Writeln(4," //gestionnaire de ressources");
    iFile.Writeln(4,"SystemResources vSR= new SystemResources();");
    iFile.Writeln(4," //global variable for port");
    iFile.Writeln(4,"  String[] portIn  = null ;");
    iFile.Writeln(4,"  String[] portOut = null;");
    iFile.Writeln(4,"  String[] LocIn  = null ;");
    iFile.Writeln(4,"  String[] LocOut = null;");
    iFile.Writeln("");
    iFile.Writeln(4," //global variable for the processFactory");
    iFile.Writeln(4,"TProcessFactory myProcessFactory = new TProcessFactory();");
    iFile.Writeln("");
    iFile.Writeln(4," //global variable for the attributes and the parameters");
    iFile.Writeln(4,"StringParameters myAttributes = null;");
    iFile.Writeln(4,"Parameters myParameters = null ;");
    iFile.Writeln(4,"");
    //temporaire
    iFile.Writeln(4,"double begin = System.currentTimeMillis();");
    iFile.Writeln(4,"double end = 0;");
    iFile.Writeln(4,"TProcessComposite myCurrentCompositeProcess = null;");
  }
 
 public void generateHeader(fr.fluxmedia.transmorpher.Graph.Servlet main) {
    iFile.Writeln("/** Generated by Transmorpher */");
    iFile.Writeln("");
    iFile.Writeln("//import Servlet classes");
    iFile.Writeln("import java.io.*;");
    iFile.Writeln("import javax.servlet.*;");
    iFile.Writeln("import javax.servlet.http.*;");
    iFile.Writeln();
    iFile.Writeln("// import transmorpher classes");
    iFile.Writeln("import fr.fluxmedia.transmorpher.TProcessFactory.*;");
    iFile.Writeln("import fr.fluxmedia.transmorpher.Utils.*;");
    iFile.Writeln("import fr.fluxmedia.transmorpher.Utils.SystemResources ;");
    iFile.Writeln("");
    iFile.Writeln("public class "+main.getName()+" extends HttpServlet {");
    iFile.Writeln();
    iFile.Writeln(2,"//gestionnaire de ressources");
    iFile.Writeln(2,"SystemResources vSR= new SystemResources();");
    iFile.Writeln(2,"//global variable for port");
    iFile.Writeln(2,"String[] portIn  = null ;");
    iFile.Writeln(2,"String[] portOut = null;");
    iFile.Writeln(2,"String[] LocIn  = null ;");
    iFile.Writeln(2,"String[] LocOut = null;");
    // La valeur par defaut devrait etre celle de ce Transmorpher.
    iFile.Writeln(2,"boolean debug_mode = false;");
    iFile.Writeln(2,"//global variable for the processFactory");
    iFile.Writeln(4,"TProcessFactory myProcessFactory = null;");
    iFile.Writeln(4,"Parameters parameters = null ;");
    iFile.Writeln();
    iFile.Writeln(2,"public void init(ServletConfig config) throws ServletException{");
    iFile.Writeln(4,"vSR= new SystemResources();");
    iFile.Writeln(4,"myProcessFactory = new TProcessFactory();");
    iFile.Writeln(4,"parameters = new Parameters();");
    iFile.Writeln(2,"}");
    iFile.Writeln();
    iFile.Writeln(2,"protected void doGet(HttpServletRequest req, HttpServletResponse res)");
    iFile.Writeln(4,"          throws ServletException, IOException {");
    iFile.Writeln(4,"   doPost(req,res);");
    iFile.Writeln(2,"}");
    iFile.Writeln();
    iFile.Writeln(2,"protected void doPost(HttpServletRequest req, HttpServletResponse res)");
    iFile.Writeln(4,"          throws ServletException, IOException {");
    iFile.Writeln();
    iFile.Writeln(4,"double begin = System.currentTimeMillis();");
    iFile.Writeln(4,"double end = 0;");
    iFile.Writeln(4,"TProcessComposite myCurrentCompositeProcess = null;");
    iFile.Writeln();
    // JE: Here are only considered the parameters that have been declared
    for( Enumeration e = main.getParameters().getNames() ; e.hasMoreElements(); ){
      Object key = e.nextElement();
      iFile.Writeln(4,"if ( req.getParameter(\""+key+"\") != null ){");
      iFile.Writeln(6,"parameters.setParameter(\""+key+"\",req.getParameter(\""+key+"\"));");
      iFile.Writeln(4,"};");
    } //end for
    iFile.Writeln();
    iFile.Writeln(4,"res.setContentType(\"text/plain\");");
    iFile.Writeln(4,"PrintWriter out = res.getWriter();");
    iFile.Writeln();
    iFile.Writeln(4,"//global variable for the attributes and the parameters");
    iFile.Writeln(4,"StringParameters myAttributes = null;");
    iFile.Writeln(4,"Parameters myParameters = null ;");
  }

 public void generateHeader(Transformer main) {
    iFile.Writeln("/** Generated by Transmorpher */");
    iFile.Writeln("");
    iFile.Writeln("//import JAXP classes");
    iFile.Writeln("import javax.*;");
    iFile.Writeln();
    iFile.Writeln("// import transmorpher classes");
    iFile.Writeln("import fr.fluxmedia.transmorpher.TProcessFactory.*;");
    iFile.Writeln("import fr.fluxmedia.transmorpher.Utils.*;");
    iFile.Writeln("import fr.fluxmedia.transmorpher.Utils.SystemResources ;");
    iFile.Writeln("");
    iFile.Writeln("public class "+main.getName()+" implements javax.Transformer {");
    iFile.Writeln();
    iFile.Writeln(2,"//gestionnaire de ressources");
    iFile.Writeln(2,"SystemResources vSR= new SystemResources();");
    iFile.Writeln(2,"//global variable for port");
    iFile.Writeln(2,"String[] portIn  = null ;");
    iFile.Writeln(2,"String[] portOut = null;");
    iFile.Writeln(2,"String[] LocIn  = null ;");
    iFile.Writeln(2,"String[] LocOut = null;");
    // La valeur par defaut devrait etre celle de ce Transmorpher.
    iFile.Writeln(2,"boolean debug_mode = false;");
    iFile.Writeln(2,"//global variable for the processFactory");
    iFile.Writeln(4,"TProcessFactory myProcessFactory = null;");
    iFile.Writeln(4,"Parameters parameters = null ;");
    iFile.Writeln();
    // JE: Here, this should not be main
    iFile.Writeln(2,"public static void main(String[] args){");
    iFile.Writeln();
    iFile.Writeln(4,"double begin = System.currentTimeMillis();");
    iFile.Writeln(4,"double end = 0;");
    iFile.Writeln(4,"TProcessComposite myCurrentCompositeProcess = null;");
    iFile.Writeln();
    // JE: Here are only considered the parameters that have been declared
    for( Enumeration e = main.getParameters().getNames() ; e.hasMoreElements(); ){
      Object key = e.nextElement();
      // JE: Here I must find the code corresponding to the transformer
      iFile.Writeln(4,"if ( req.getParameter(\""+key+"\") != null ){");
      iFile.Writeln(6,"parameters.setParameter(\""+key+"\",req.getParameter(\""+key+"\"));");
      iFile.Writeln(4,"};");
    } //end for
    iFile.Writeln();
    iFile.Writeln(4,"res.setContentType(\"text/plain\");");
    iFile.Writeln(4,"PrintWriter out = res.getWriter();");
    iFile.Writeln();
    iFile.Writeln(4,"//global variable for the attributes and the parameters");
    iFile.Writeln(4,"StringParameters myAttributes = null;");
    iFile.Writeln(4,"Parameters myParameters = null ;");
  }

  public void generateEnd() {
    iFile.Writeln(4,"end = System.currentTimeMillis();");
    iFile.Writeln(4,"if (debug_mode) System.err.println(\">> End of execution (\"+(end-begin)+\")\");");
    iFile.Writeln(2,"} //end main");
    iFile.Writeln("} //end class");
    iFile.Close();
  }
 } //end class

