/**
 * $Id: ExecutionStructure.java,v 1.13 2001/12/12 12:48:12 jerome Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/** define the structure for a transmorpher execution
*/


package fr.fluxmedia.transmorpher.Parser;

//import XML CLasses

import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerConfigurationException;

// import SAX classes

import org.xml.sax.SAXException;

// import java classes

import java.util.Hashtable;
import java.util.Vector;
import java.util.Enumeration;
import java.util.ListIterator;
import java.io.IOException;

//import transmorpher classes

import fr.fluxmedia.transmorpher.TProcessFactory.TProcess;
import fr.fluxmedia.transmorpher.TProcessFactory.TApplyProcess;
import fr.fluxmedia.transmorpher.TProcessFactory.TProcessComposite;
import fr.fluxmedia.transmorpher.TProcessFactory.TMain;
import fr.fluxmedia.transmorpher.TProcessFactory.TProcessFactory;

import fr.fluxmedia.transmorpher.Graph.Main;
import fr.fluxmedia.transmorpher.Graph.*;
import fr.fluxmedia.transmorpher.Utils.LinearIndexedStruct ;
import fr.fluxmedia.transmorpher.Utils.Parameters ;

public class ExecutionStructure {
 
  TMain iMain = null;
  TProcessFactory iProcessFactory = null;
  Transmorpher iTransmorpher = null ;
  public ExecutionStructure(fr.fluxmedia.transmorpher.Graph.Transmorpher pTransmorpher) {
    try {
      iTransmorpher = pTransmorpher ;
      iProcessFactory = new TProcessFactory();
      // JE: The problem here is that it is generated from the main
      if ( pTransmorpher.getMain() != null ){
	  iMain = generateExec((Transformation)(pTransmorpher.getMain()));
      } else {
	  System.err.println("Cannot generate execution structure for mainless Transformation");
      }
    } catch (Exception e) {
      System.err.println("Error:" + e );
    } //end try
  } //end
 
  public void exec(Parameters p) throws Exception {
      if ( iMain != null ){
	  //for( Enumeration e = p.getNames() ; e.hasMoreElements(); ){
	  //String key = (String)e.nextElement();
      //System.err.println("Param "+key+" set to "+(String)p.getParameter(key));
      //} //ENd for
	  iMain.bindParameters(p);
	  iMain.execProcess();
      } else {
	  System.err.println("Cannot execute mainless Transformation");
      }
  }

    // Here I must start to consider: StdIn and StdOut...
    // BUT THERE SHOULD BE STUFF FOR SERVLET AND TRANSFORMER
  private TMain generateExec(Transformation pMain) throws Exception {
      if ( pMain != null ){
	  iMain= (TMain)startMain(pMain);
      } else {
	  System.err.println("Cannot generate execution structure for mainless Transformation");
      }
    return iMain;
  }
  
  public final TProcess startProcess(Transformation currentGraphElement,TProcess currentProcess ) {
    String localName = currentGraphElement.getType();
    try {
      
      if (currentGraphElement  instanceof fr.fluxmedia.transmorpher.Graph.Process) {
          //System.out.println("startElement(Transformation): " + localName);
          //startProcess();
      } else if (currentGraphElement  instanceof Main) {
          //On appel le run a la fin du main
          //System.out.println("startElement (Transformation) : " + localName);
          return startMain(currentGraphElement);
      }  else if (currentGraphElement  instanceof Repeat) {
          //System.out.println("startElement (Transformation) : " + localName);
          //startProcessLoop(atts);
      } else if (currentGraphElement  instanceof Serialize) {
          //System.out.println("startElement (Transformation) : " + localName);
          //startProcessSerializer(atts);
      } else {
          System.out.println("startElement (Transformation) : ELEMENT INCONU" + localName);
      } //end if
      
    } catch (Exception e) {
      System.out.println("Erreur"+e);
    }//end try
   return null;
  } // startElement(String namespaceURI, String localName, String qname, Attributes atts)
 
    // JE: object-oriented programming?
    public final TProcess startProcess(Call currentGraphElement,TProcess currentProcess ) {
	String localName = currentGraphElement.getId();
	try {
	    if (currentGraphElement  instanceof ApplyExternal) {
		//System.out.println("startElement (Call)(Xslt_) : " + localName);
		startProcessXslt(currentGraphElement,(TProcessComposite)currentProcess);
	    } else if (currentGraphElement  instanceof ApplyProcess) {
		//System.out.println("startElement (Call)(ApplyProcess) : " + localName);
		startProcessApplyProcess(currentGraphElement,(TProcessComposite)currentProcess);
	    } else if (currentGraphElement  instanceof ApplyQuery) {
		//System.out.println("startElement (Call)(query) : " + localName);
		startProcessQuery(currentGraphElement,(TProcessComposite)currentProcess);
	    } else if (currentGraphElement  instanceof ApplyRuleset) {
		//System.out.println("startElement (Call) (ApplyRuleset):  " + localName);
		startRuleSet(currentGraphElement,(TProcessComposite)currentProcess);
	    } else if (currentGraphElement  instanceof Generate) {
		//System.out.println("startElement (Call)(Generate) : " + localName);
		startProcessReader(currentGraphElement,(TProcessComposite)currentProcess);
	    } else if (currentGraphElement  instanceof Serialize) {
		//System.out.println("startElement (Call) (Serialize): " + localName);
		startProcessSerializer(currentGraphElement,(TProcessComposite)currentProcess);
	    } else if (currentGraphElement  instanceof Dispatch ) {
		//System.out.println("startElement (Call) (Dispatch): " + localName);
		startProcessDispatcher(currentGraphElement,(TProcessComposite)currentProcess);
	    } else if (currentGraphElement  instanceof Merge) {
		//System.out.println("startElement (Call) (Merge): " + localName);
		startProcessConnector(currentGraphElement,(TProcessComposite)currentProcess);
	    } else {
		System.out.println("[ExecutionStructure]startElement (Call) : ELEMENT INCONU" + localName);
	    } //end if
	    
	} catch (Exception e) {
	    System.out.println("[ExecutionStructure]startElement : Erreur"+e);
	    e.printStackTrace();
	}//end try
	return null;
    } // startElement(String namespaceURI, String localName, String qname, Attributes atts)
  
 
 
  protected final String[] convertPortList(PortList p) {
      int size = p.length() ;
      String[] vPort = new String[size] ;
      for (int i=0; i<size; i++) { vPort[i]= p.getPort(i).getName(); } //end for
      return vPort ;
  } //end proc
 
  protected final TProcess startMain(Transformation pMain)
    throws Exception {
  
    String[] vPortIn = convertPortList(pMain.inPorts());
    String[] vPortOut = convertPortList(pMain.outPorts());
    TProcess vCurrent = TProcessFactory.newMain(vPortIn,vPortOut,pMain.getParameters());
    for( ListIterator l = ((fr.fluxmedia.transmorpher.Graph.Process)pMain).getCalls().listIterator(); l.hasNext() ; ){
	startProcess(((Call)l.next()),vCurrent);
    }
    return vCurrent ;
  } //end proc

 
 protected  final void startProcessReader(Call currentGraphElement,
                                          TProcessComposite currentProcess)
     throws Exception {
     String[] vPortOut = convertPortList(currentGraphElement.outPorts());
//    System.out.println("[ExecutionStructure]Creation d'un TReader"
//                        + currentGraphElement.getParameters());
     TProcess vCurrent = iProcessFactory.newGenerator(vPortOut,
					     currentGraphElement.getParameters(),
					     currentGraphElement.getAttributes());
     currentProcess.addProcess(vCurrent);
 } //end proc

 protected  final void startProcessSerializer(Call currentGraphElement,
                                              TProcessComposite currentProcess)
  throws Exception {
  
    TProcess vCurrent = null;
    String[] vPortIn = convertPortList(currentGraphElement.inPorts());
    //String f = (String)currentGraphElement.getParameters().getParameter("file") ;
    //System.out.println("[ExecutionStrucutre] "+currentGraphElement.getAttributes().getParameter("file"));
    vCurrent = iProcessFactory.newSerializer(vPortIn,
                                             currentGraphElement.getParameters(),
                                             currentGraphElement.getAttributes());
    currentProcess.addProcess(vCurrent);
  } //end proc

 
 protected  final void startProcessDispatcher(Call currentGraphElement,
                                              TProcessComposite currentProcess) {
                                               
   String[] vPortIn = convertPortList(currentGraphElement.inPorts());
   String[] vPortOut = convertPortList(currentGraphElement.outPorts());
   //String t = (String)currentGraphElement.getParameters().getParameter("type") ;
   TProcess vCurrent = TProcessFactory.newDispatcher(vPortIn,vPortOut,currentGraphElement.getParameters());
   currentProcess.addProcess(vCurrent);
  } //end proc

 

  protected  final void startProcessConnector(Call currentGraphElement,
                                              TProcessComposite currentProcess) {
                                               
    String[] vPortIn = convertPortList(currentGraphElement.inPorts());
    String[] vPortOut = convertPortList(currentGraphElement.outPorts());
    //String t = (String)currentGraphElement.getParameters().getParameter("type") ;
    TProcess vCurrent = TProcessFactory.newConnector(vPortIn,vPortOut,currentGraphElement.getParameters() );
    currentProcess.addProcess(vCurrent);
  } //end proc



  protected  final void startProcessXslt(Call currentGraphElement,
                                         TProcessComposite currentProcess)
      throws TransformerException, TransformerConfigurationException,
             SAXException, IOException {
 
    String[] vPortIn = convertPortList(currentGraphElement.inPorts());
    String[] vPortOut = convertPortList(currentGraphElement.outPorts());
    //currentGraphElement.getProcess().
    //String t = (String)currentGraphElement.getParameters().getParameter("type") ;
    //String f = (String)currentGraphElement.getParameters().getParameter("file") ;
    //System.out.println("startProcessXslt : " + t + "," + f);
    TProcess vCurrent = TProcessFactory.newExternal(vPortIn,vPortOut,currentGraphElement.getParameters());
    currentProcess.addProcess(vCurrent);
    } //end proc
     
   protected  final void startRuleSet(Call currentGraphElement,
                                      TProcessComposite currentProcess)
     throws TransformerException, TransformerConfigurationException,
            SAXException, IOException {
    
    String[] vPortIn = convertPortList(currentGraphElement.inPorts());
    String[] vPortOut = convertPortList(currentGraphElement.outPorts());
    //currentGraphElement.getProcess().
    //String r = (String)currentGraphElement.getParameters().getParameter("ref") ;
    //String s = (String)currentGraphElement.getParameters().getParameter("strategy") ;
    
    //recupere le nom de fichier
    String ref = currentGraphElement.getAttributes().getStringParameter("ref");
    Transmorpher t = currentGraphElement.getProcess().getTransmorpher() ;
    String f = t.getTransformation(ref).getAttributes().getStringParameter("file");
    //static car construit a partir du nom de l'elelent
     currentGraphElement.getAttributes().setParameter("file",f);
    TProcess vCurrent = TProcessFactory.newRuleSet(vPortIn,vPortOut,
                                                   currentGraphElement.getParameters(),
                                                   currentGraphElement.getAttributes());
    currentProcess.addProcess(vCurrent);
   
  } //end proc

  protected  final void startProcessQuery(Call currentGraphElement,
                                          TProcessComposite currentProcess)
    throws TransformerException, TransformerConfigurationException,
           SAXException, IOException  {
 
    String[] vPortIn = convertPortList(currentGraphElement.inPorts());
    String[] vPortOut = convertPortList(currentGraphElement.outPorts());
//    String r = (String)currentGraphElement.getParameters().getParameter("ref") ;
//    String t = (String)currentGraphElement.getParameters().getParameter("type") ;
//                //recupere le nom de fichier
    String ref = currentGraphElement.getAttributes().getStringParameter("ref");
    Transmorpher tr = currentGraphElement.getProcess().getTransmorpher() ;
    String f = tr.getTransformation(ref).getAttributes().getStringParameter("file");
    //static car construit a partir du nom de l'elelent
    currentGraphElement.getAttributes().setParameter("file",f);
    TProcess vCurrent = TProcessFactory.newApplyQuery(vPortIn,vPortOut,
                                                      currentGraphElement.getParameters(),
                                                      currentGraphElement.getAttributes());

    currentProcess.addProcess(vCurrent);
  } //end proc

  protected  final void startProcessApplyProcess(Call currentGraphElement,
                                                 TProcessComposite currentProcess)
    throws TransformerException, TransformerConfigurationException,
           SAXException, IOException  {

    String[] vPortIn = convertPortList(currentGraphElement.inPorts());
    String[] vPortOut = convertPortList(currentGraphElement.outPorts());
    String r = currentGraphElement.getAttributes().getStringParameter("ref") ;
    LinearIndexedStruct vCalls = ((fr.fluxmedia.transmorpher.Graph.Process)iTransmorpher.getTransformation(r)).getCalls();
            
    //System.out.println("[ExecutionStructure]ApplyProcess : getTransformation"
    //                    +((fr.fluxmedia.transmorpher.Graph.Process)iTransmorpher.getTransformation(r)));
            
    TProcess vCurrent = TProcessFactory.newApplyProcess(vPortIn,vPortOut,
                                                        currentGraphElement.getParameters(),
                                                        currentGraphElement.getAttributes());
    PortList LocIn = ((fr.fluxmedia.transmorpher.Graph.Process)iTransmorpher.getTransformation(r)).inPorts();
    PortList LocOut= ((fr.fluxmedia.transmorpher.Graph.Process)iTransmorpher.getTransformation(r)).outPorts();
            
    ((TApplyProcess)vCurrent).setLocalName(LocIn.getNames(),LocOut.getNames());
            
    for( ListIterator l = vCalls.listIterator(); l.hasNext() ; ){
      //((Call)l.next()).generateXML();
      startProcess(((Call)l.next()),vCurrent);
    }
    //vCurrent.setName(vFather.getName()+iPA.getId());
    currentProcess.addProcess(vCurrent);
  } //end proc

 } //end class

