/**
 * $Id: TApplyQuery.java,v 1.11 2001/12/12 13:11:13 jerome Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package fr.fluxmedia.transmorpher.TProcessFactory ;

// Imported TraX classes

import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamSource;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.sax.SAXTransformerFactory;
import javax.xml.transform.sax.TransformerHandler;
import javax.xml.transform.sax.SAXSource;
import javax.xml.transform.sax.SAXResult;

// Imported SAX Classes

import org.xml.sax.Attributes;
import org.xml.sax.helpers.XMLReaderFactory;
import org.xml.sax.XMLReader;
import org.xml.sax.SAXException ;
import org.xml.sax.SAXParseException;
import org.xml.sax.InputSource;
import org.xml.sax.Locator;

// Imported java.io classes

import java.io.IOException;
import java.util.Hashtable;

//Imported Transmorpher CLasses

import fr.fluxmedia.transmorpher.Files.ReadWrite ;
import fr.fluxmedia.transmorpher.Files.Constants ;
import fr.fluxmedia.transmorpher.Utils.Parameters;
import fr.fluxmedia.transmorpher.Utils.StringParameters;

public final class TApplyQuery
    extends TTransformer {
    
  private static final String DEFAULT_PARSER_NAME = "com.ibm.xml.parsers.SAXParser";
       
    /** XML Parser */
    javax.xml.parsers.SAXParser iParser = null;
      
    ReadWrite FileRW = null;
    
    String iRoot = null;
   
    /** the ref  for the file of the transformer*/
    protected String ref = null;
 
     
  public TApplyQuery (String[] pIn, String[] pOut,
                      Parameters pParam,
                      StringParameters staticAttributes)
    throws TransformerException,
           SAXException, IOException,
           TransformerConfigurationException{
  
    super(pIn,pOut,pParam,(String)staticAttributes.getStringParameter("file"));
    ref = (String)pParam.getParameter("ref");
    type = (String)pParam.getParameter("type");
    //System.out.println("[TApplyQuerry]constructor : "+ref);
    //System.out.println("[TApplyQuerry]constructor : "+staticAttributes.getStringParameter("file"));
   }

 
  public void setRef(String ref){
    this.ref=ref;
  }

  public String getRef(){
    return ref;
  }

  public String getFile(){
    return iXSLFile;
  }

  

    /*---------------------------------     void generatePort  -----------------------------------------*/

  public void generatePort(){
  
    String nameI = nameIn[0];
    String nameO = nameOut[0];

    if(nameFather!=null) {
      nameI = nameFather+"-"+nameI;
      nameO = nameFather+"-"+nameO;
    } //end fi
  
    iListIn [0] = new XML_Port(nameI,this,iTransformerHandler,0,XML_Port.IN);
    iListOut[0] = new XML_Port(nameO,this,iTransformerHandler,0,XML_Port.OUT);
  } //end proc
    
}//end class

