/**
 * $Id: TConnector.java,v 1.15 2001/12/12 13:11:13 jerome Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/**
  * This class based on the TProcessBasic allow to define
  * a Connector. A connector is a N -> 1 element.
  * It 's allow to merge a set of ContentHandler flow

  * @author Laurent Tardif (laurent.tardif@inrialpes.fr)
  * @since jdk 1.2 / SAX 2.0
  @see fr.fluxmedia.transmorpher.TProcessFactory.OneMixer
  @see fr.fluxmedia.transmorpher.TProcessFactory.MultipleMixer
  @see fr.fluxmedia.transmorpher.TProcessFactory.ProcessBasic
 */

package fr.fluxmedia.transmorpher.TProcessFactory ;

// Imported transmorpher classes
import fr.fluxmedia.transmorpher.Files.ReadWrite;
import fr.fluxmedia.transmorpher.Utils.Parameters;

// Imported SAX classes

import org.xml.sax.ContentHandler;

// java classes
import java.util.Hashtable;


public final class TConnector
  extends TProcessBasic {
    
  /** The multiple mixer which realize the merge */
  MultipleMixer iMM = null;
    
  /** the empty constructor */
  //public TConnector (){}
   /*  public TConnector(String[] pIn, String[] pOut) {
    super(pIn,pOut);
  
    // The first current mixer is the first one
    iMM = new MultipleMixer(iNbIn);
    iMM.getMixer(0).setCurrent(true);
  }
*/
  public TConnector(String[] pIn, String[] pOut,Parameters pParam) {
    super(pIn,pOut);
  
    // The first current mixer is the first one
    iMM = new MultipleMixer(iNbIn);
    iMM.getMixer(0).setCurrent(true);
    type = (String)pParam.getParameter("type");;
  }
    
  /** Allow to set the content handler on Mixer for out port*/
  public final void setContentHandler(ContentHandler pContentHandler ) {
    iMM.setContentHandler(pContentHandler);
  }
    
  /** Allow to get the content handler for in port */
  public final ContentHandler getContentHandler( ) {
    return iMM.getContentHandler();
  }
    
  public void generatePort(){
  
    if(nameFather==null) {
      for (int i=0;i<iNbIn; i++) {
        iListIn[i] = new XML_Port(nameIn[i],this,iMM.getMixer(i),i,XML_Port.IN);
      }
        iListOut[0]= new XML_Port(nameOut[0],this,this,0,XML_Port.OUT);
    } else {
      for (int i=0;i<iNbIn; i++) {
        iListIn[i] = new XML_Port(nameFather+"-"+nameIn[i],this,iMM.getMixer(i),i,XML_Port.IN);
      }
        iListOut[0]= new XML_Port(nameFather+"-"+nameOut[0],this,this,0,XML_Port.OUT);
    } //end if
  } //end proc
  
} //end class
