/**
 * $Id: TSerializer.java,v 1.13 2001/12/12 13:11:13 jerome Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/**
  * This class offer a serializer mechanisme. A way to finish the transphormation process
  * bye writing XML output file
  *
  * @author laurent tardif@inrialpes.fr
  * @date 10 02 2001
  * @since jdk 1.3 && SAX 2.0
  */

package fr.fluxmedia.transmorpher.TProcessFactory ;

import fr.fluxmedia.transmorpher.Files.ReadWrite;
import fr.fluxmedia.transmorpher.Utils.Parameters;
import fr.fluxmedia.transmorpher.Utils.StringParameters;

// Imported SAX classes

import org.xml.sax.SAXException;
import org.xml.sax.ContentHandler;

// Imported Serializer classes
// JE: why this depends on Xalan?

import org.apache.xalan.serialize.Serializer;
import org.apache.xalan.serialize.SerializerFactory;
import org.apache.xalan.templates.OutputProperties;

// Imported java.io classes
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.io.File;
import java.io.IOException;

import java.util.Hashtable;


public final class TSerializer
  extends TProcessBasic{
    
  /** the serializer */
  Serializer serializer = null;
    
  String XML_Filename = null;
    
  java.util.Properties Op = OutputProperties.getDefaultMethodProperties("xml");

  public TSerializer (String[] pIn,Parameters pParam,StringParameters pStaticAttributes)
    throws SAXException, IOException {
    super(pIn,new String[0]);
    type = pStaticAttributes.getStringParameter("type");
    XML_Filename =(String) pParam.getParameter("file");
     try{
      if(type.equals("standardOutput")) {
        serializer = SerializerFactory.getSerializer(Op);
        serializer.setOutputStream(System.out);
      } else {
        FileOutputStream FOS = null;
        setOutputProperties();
        serializer = SerializerFactory.getSerializer(Op);
        FOS =  new FileOutputStream(new File(XML_Filename));
        serializer.setOutputStream(FOS);
      } //end if
    } catch(IOException IOE) {
      System.out.println("[TSerialisser]erreur : " + IOE);
      System.out.println("[TSerialisser]erreur : f=" + XML_Filename);
      IOE.printStackTrace();
    } //end try
    iListIn[0]=new XML_Port(pIn[0],this,(ContentHandler)serializer.asContentHandler(),0,XML_Port.IN);
  }
    
    
  /** The constructor for the standard output serialization */
//  public TSerializer (String[] pIn,OutputStream output)
//    throws SAXException, IOException   {
//    super(pIn,new String[0]);
//    Op.setProperty("encoding","iso-8859-1");
//    serializer = SerializerFactory.getSerializer(Op);
//    serializer.setOutputStream(output);
//     
//    iListIn[0]=new XML_Port(pIn[0],this,(ContentHandler)serializer.asContentHandler(),0,XML_Port.IN);
//  }
  
   //public TSerializer (String[] pIn,String type,String file,OutputStream output) {
   

  public void setFileName(String pFileName){
    this.XML_Filename = pFileName;
  }
    
  public void setOutputProperties(){
    Op.setProperty("encoding","iso-8859-1");
    if(XML_Filename!=null){
      if (XML_Filename.endsWith("html")) {
        Op = OutputProperties.getDefaultMethodProperties("xml");
      } else if (XML_Filename.endsWith("xml")) {
        Op = OutputProperties.getDefaultMethodProperties("xml");
      } else if (XML_Filename.endsWith("bib")) {
        Op = OutputProperties.getDefaultMethodProperties("text");
      } //end if
    } //end if
  } //end proc
  
  
   public void generatePort(){
    String nameI= nameIn[0];
    if(nameFather != null)
      nameI = nameFather+"-"+nameI;
    try{
      iListIn[0]=new XML_Port(nameI,this,(ContentHandler)serializer.asContentHandler(),0,XML_Port.IN);
    }
    catch(Exception e) {
      System.out.println("[Tserialiszer] generatePort" +e);
    } //end try
  }
    
} //end class
